<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>G-CTMQC: classical_evolution Module Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">G-CTMQC
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('namespaceclassical__evolution.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions/Subroutines</a>  </div>
  <div class="headertitle">
<div class="title">classical_evolution Module Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>The module contains a collection of subroutines used in the classical evolution of the nuclei.  
<a href="namespaceclassical__evolution.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions/Subroutines</h2></td></tr>
<tr class="memitem:aa56590b0cb9845368cd3d5345b908857"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceclassical__evolution.html#aa56590b0cb9845368cd3d5345b908857">update_position</a> (x, v)</td></tr>
<tr class="memdesc:aa56590b0cb9845368cd3d5345b908857"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update of the classical positions according to the velocity Verlet algorithm.  <a href="namespaceclassical__evolution.html#aa56590b0cb9845368cd3d5345b908857">More...</a><br /></td></tr>
<tr class="separator:aa56590b0cb9845368cd3d5345b908857"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59905627b30c87e644aeb0b1c008579f"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceclassical__evolution.html#a59905627b30c87e644aeb0b1c008579f">update_velocity</a> (v, force)</td></tr>
<tr class="memdesc:a59905627b30c87e644aeb0b1c008579f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update of the classical velocities according to the velocity Verlet algorithm.  <a href="namespaceclassical__evolution.html#a59905627b30c87e644aeb0b1c008579f">More...</a><br /></td></tr>
<tr class="separator:a59905627b30c87e644aeb0b1c008579f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1c31050918fc14c897af2fe659432fc"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceclassical__evolution.html#ae1c31050918fc14c897af2fe659432fc">non_adiabatic_force</a> (coeff, force, acc_force, k_li, trajlabel)</td></tr>
<tr class="memdesc:ae1c31050918fc14c897af2fe659432fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Definition of the classical nuclear force depending on the type of calculation that is executed.  <a href="namespaceclassical__evolution.html#ae1c31050918fc14c897af2fe659432fc">More...</a><br /></td></tr>
<tr class="separator:ae1c31050918fc14c897af2fe659432fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>The module contains a collection of subroutines used in the classical evolution of the nuclei. </p>
<dl class="section author"><dt>Author</dt><dd>Federica Agostini, Institut de Chimie Physique, University Paris-Saclay. </dd></dl>
</div><h2 class="groupheader">Function/Subroutine Documentation</h2>
<a id="ae1c31050918fc14c897af2fe659432fc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae1c31050918fc14c897af2fe659432fc">&#9670;&nbsp;</a></span>non_adiabatic_force()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine classical_evolution::non_adiabatic_force </td>
          <td>(</td>
          <td class="paramtype">complex(kind=qp), dimension(nstates), intent(in)&#160;</td>
          <td class="paramname"><em>coeff</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(n_dof), intent(inout)&#160;</td>
          <td class="paramname"><em>force</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(n_dof,nstates), intent(in)&#160;</td>
          <td class="paramname"><em>acc_force</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(nstates,nstates), intent(in)&#160;</td>
          <td class="paramname"><em>k_li</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer, intent(in)&#160;</td>
          <td class="paramname"><em>trajlabel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition of the classical nuclear force depending on the type of calculation that is executed. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">trajlabel</td><td>label indicating the trajectory number in the swarm </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">coeff</td><td>coefficients of the expansion of the electronic time-dependent wavefunction in the basis used for the dynamics </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">acc_force</td><td>gradient of the adiabatic or diabatic force accumulated over time along the trajectory trajlabel </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">k_li</td><td>quantity related to the quantum momentum and responsible for decoherence; it is identically zero for Ehrenfest and surface hopping calculations </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">force</td><td>classical force used to evolve the trajectory trajlabel </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">i,j</td><td>integer indices </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">i_dof</td><td>index running on the n_dof degrees of freedom </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">check</td><td>control variable for allocation errors </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">my_rho</td><td>temporary array of the electronic density matrix </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The value of the classical force at the position of the trajectory is returned. </dd></dl>

<p class="definition">Definition at line <a class="el" href="classical__evolution_8f90_source.html#l00100">100</a> of file <a class="el" href="classical__evolution_8f90_source.html">classical_evolution.f90</a>.</p>

</div>
</div>
<a id="aa56590b0cb9845368cd3d5345b908857"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa56590b0cb9845368cd3d5345b908857">&#9670;&nbsp;</a></span>update_position()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine classical_evolution::update_position </td>
          <td>(</td>
          <td class="paramtype">real(kind=dp), dimension(n_dof), intent(inout)&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(n_dof), intent(in)&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Update of the classical positions according to the velocity Verlet algorithm. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">x</td><td>nuclear position </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>nuclear velocity </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">my_x</td><td>temporary nuclear position for internal calculations </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The updated nuclear position is returned. </dd></dl>

<p class="definition">Definition at line <a class="el" href="classical__evolution_8f90_source.html#l00041">41</a> of file <a class="el" href="classical__evolution_8f90_source.html">classical_evolution.f90</a>.</p>

</div>
</div>
<a id="a59905627b30c87e644aeb0b1c008579f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a59905627b30c87e644aeb0b1c008579f">&#9670;&nbsp;</a></span>update_velocity()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine classical_evolution::update_velocity </td>
          <td>(</td>
          <td class="paramtype">real(kind=dp), dimension(n_dof), intent(inout)&#160;</td>
          <td class="paramname"><em>v</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(n_dof), intent(in)&#160;</td>
          <td class="paramname"><em>force</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Update of the classical velocities according to the velocity Verlet algorithm. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">force</td><td>nuclear force </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">v</td><td>nuclear velocity </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">my_v</td><td>temporary nuclear velocity for internal calculations </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The updated nuclear velocity is returned. </dd></dl>

<p class="definition">Definition at line <a class="el" href="classical__evolution_8f90_source.html#l00070">70</a> of file <a class="el" href="classical__evolution_8f90_source.html">classical_evolution.f90</a>.</p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceclassical__evolution.html">classical_evolution</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
